class Metaball2D {
  float x,y;
  float strength;
  float xspeed,yspeed;
  
  float dx,dy;
  
  Metaball2D( float _x, float _y, float _strength ) {
    x = _x;
    y = _y;
    strength = _strength;
    
    xspeed = random(1,2);
    yspeed = random(1,2);
  }
  
  void move() {
    x += xspeed;
    y += yspeed;
    
    if(x+xspeed>width || x-10<0) xspeed *= -1;
    if(y+yspeed>height || y-10<0) yspeed *= -1;
  } 
  
  // returns a "influence" value, given a single pixel coordinate
  float getInfluence(float px, float py) {
    dx = (x-px);
    dy = (y-py);
    
    //return strength/(dx*dx + dy*dy+0.01f);
    return strength/(sqrt( sq(dx) + sq(dy) ));
  }
}
