/***************************
* Metaballs
* - Utilizes code inspired by some guy named Ale_K on the Processing forums. Which in turn was inspired by v3ga and Koenie. Both of which didn't inspire me.
*/

import processing.opengl.*;

int ballCount;
Metaball2D[] mbs;

void setup() {
  size(200,200,P3D);

  background(0);
  
  // initalize metaballs
  ballCount = 3;
  mbs = new Metaball2D[ballCount];
  
  mbs[0] = new Metaball2D(100,80,100);
  mbs[1] = new Metaball2D(200,100,50);
  mbs[2] = new Metaball2D(50,100,35);
  
  //noLoop();
  frameRate(30);  
}

void draw() {
  background(0);
  
  // move each ball
  for(int m=0; m<ballCount; m++) { mbs[m].move(); }
  
  
  // main rendering
  for(int i=0; i<width; i++) {
    for(int j=0; j<height; j++) {
      float inf = 0.0f;
      for(int m=0; m<ballCount; m++) {
        inf += mbs[m].getInfluence(i,j);
      }
      
      if(inf>1.7) {
        int nn = (int)(inf*150);
        float nnn = 250;
       
        stroke(nn-nnn,(nn-nnn)*.8f,(nn-nnn)*.5f,nn-nnn);
        //stroke(255,255,255);
        point(i,j);
      }
    }
  }
  
  //saveFrame("seq2/###.png");
}
          
 
